AbstractSymbolList (BioJava-1.5-beta API)
Keywords: org.biojava.bio.symbol.AbstractSymbolList class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.biojava.bio.symbol
Class AbstractSymbolList

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.symbol.AbstractSymbolList

All Implemented Interfaces:
  SymbolList, Changeable

Direct Known Subclasses:
  AbstractULAlignment, AbstractULAlignment.SubULAlignment, AssembledSymbolList, ChunkedSymbolList, DummySymbolList, NewAssembledSymbolList, PackedSymbolList, SimpleAlignment, SimpleGappedSymbolList, SimpleSymbolList

    public abstract class AbstractSymbolList

extends AbstractChangeable
implements SymbolList

Abstract helper implementation of the SymbolList core interface. To produce a concrete SymbolList implementation, you need only implement the `getAlphabet`, `length` and `symbolAt` methods. Iterators and sublists are handled for you automatically.

This class makes many custom SymbolList implementations very quick to implement. See org.biojava.bio.seq.tools.ComplementSymbolList for an example of this.

To make a mutable SymbolList, override the implementation of edit to perform the apropreate edit. If your implementation of SymbolList is a view onto an underlying SymbolList, then you must forward any apropreate edit requests to that list, and forward all events from the underlying list to your listeners.

Author:
  Thomas Down, Matthew Pocock

Nested Class Summary
`class` | `AbstractSymbolList.EditScreener` This adapter screens all edit events to see if they overlap with a window of interest.
`class` | `AbstractSymbolList.EditTranslater` This translates edit events that fall within a window into window co-ordinates.

Field Summary

Fields inherited from interface org.biojava.bio.symbol.SymbolList
`EDIT, EMPTY_LIST`

Constructor Summary
`protected` | `AbstractSymbolList()`

Method Summary
`void` | `edit(Edit edit)` Apply an edit to the SymbolList as specified by the edit object.
`boolean` | `equals(Object o)` Provides logical equality for two SymbolLists that share the same list of canonical symbols
`int` | `hashCode()`
`Iterator` | `iterator()` An Iterator over all Symbols in this SymbolList.
`String` | `seqString()` Stringify this symbol list.
`SymbolList` | `subList(int start, int end)` Return a new SymbolList for the symbols start to end inclusive.
`String` | `subStr(int start, int end)` Return a region of this symbol list as a String.
`List` | `toList()` Returns a List of symbols.
`String` | `toString()`

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, getChangeSupport, hasListeners, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.biojava.bio.symbol.SymbolList
`getAlphabet, length, symbolAt`

Methods inherited from interface org.biojava.utils.Changeable
`addChangeListener, addChangeListener, isUnchanging, removeChangeListener, removeChangeListener`

Constructor Detail

### AbstractSymbolList

    protected AbstractSymbolList()

Method Detail

### iterator

    public Iterator iterator()

  Description copied from interface: `SymbolList`
  An Iterator over all Symbols in this SymbolList.

  This is an ordered iterator over the Symbols. It cannot be used to edit the underlying symbols.

  Specified by:
    `iterator` in interface `SymbolList`
  Returns:
    an iterator

### subList

    public SymbolList subList(int start,
                              int end)

  Description copied from interface: `SymbolList`
  Return a new SymbolList for the symbols start to end inclusive.

  The resulting SymbolList will count from 1 to (end-start + 1) inclusive, and refer to the symbols start to end of the original sequence.

  Specified by:
    `subList` in interface `SymbolList`
  Parameters:
    `start` - the first symbol of the new SymbolList
    `end` - the last symbol (inclusive) of the new SymbolList

### toList

    public List toList()

  Description copied from interface: `SymbolList`
  Returns a List of symbols.

  This is an immutable list of symbols. Do not edit it.

  Specified by:
    `toList` in interface `SymbolList`
  Returns:
    a List of Symbols

### seqString

    public String seqString()

  Description copied from interface: `SymbolList`
  Stringify this symbol list.

  It is expected that this will use the symbol's token to render each symbol. It should be parsable back into a SymbolList using the default token parser for this alphabet.

  Specified by:
    `seqString` in interface `SymbolList`
  Returns:
    a string representation of the symbol list

### subStr

    public String subStr(int start,
                         int end)

  Description copied from interface: `SymbolList`
  Return a region of this symbol list as a String.

  This should use the same rules as seqString.

  Specified by:
    `subStr` in interface `SymbolList`
  Parameters:
    `start` - the first symbol to include
    `end` - the last symbol to include
  Returns:
    the string representation

### edit

    public void edit(Edit edit)
              throws IllegalAlphabetException,
                     ChangeVetoException

  Description copied from interface: `SymbolList`
  Apply an edit to the SymbolList as specified by the edit object.

  ## Description

  All edits can be broken down into a series of operations that change contiguous blocks of the sequence. This represent a one of those operations.

  When applied, this Edit will replace 'length' number of symbols starting a position 'pos' by the SymbolList 'replacement'. This allow to do insertions (length=0), deletions (replacement=SymbolList.EMPTY_LIST) and replacements (length>=1 and replacement.length()>=1).

  The pos and pos+length should always be valid positions on the SymbolList to:

  - be edited (between 0 and symL.length()+1).
  - To append to a sequence, pos=symL.length()+1, pos=0.
  - To insert something at the beginning of the sequence, set pos=1 and length=0.

  ## Examples

  `

       SymbolList seq = DNATools.createDNA("atcaaaaacgctagc");
       System.out.println(seq.seqString());

       // delete 5 bases from position 4
       Edit ed = new Edit(4, 5, SymbolList.EMPTY_LIST);
       seq.edit(ed);
       System.out.println(seq.seqString());

       // delete one base from the start
       ed = new Edit(1, 1, SymbolList.EMPTY_LIST);
       seq.edit(ed);

       // delete one base from the end
       ed = new Edit(seq.length(), 1, SymbolList.EMPTY_LIST);
       seq.edit(ed);
       System.out.println(seq.seqString());

       // overwrite 2 bases from position 3 with "tt"
       ed = new Edit(3, 2, DNATools.createDNA("tt"));
       seq.edit(ed);
       System.out.println(seq.seqString());

       // add 6 bases to the start
       ed = new Edit(1, 0, DNATools.createDNA("aattgg");
       seq.edit(ed);
       System.out.println(seq.seqString());

       // add 4 bases to the end
       ed = new Edit(seq.length() + 1, 0, DNATools.createDNA("tttt"));
       seq.edit(ed);
       System.out.println(seq.seqString());

       // full edit
       ed = new Edit(3, 2, DNATools.createDNA("aatagaa");
       seq.edit(ed);
       System.out.println(seq.seqString());

  `

  Specified by:
    `edit` in interface `SymbolList`
  Parameters:
    `edit` - the Edit to perform
  Throws:
    `IllegalAlphabetException` - if the SymbolList to insert has an incompatible alphabet
    `ChangeVetoException` - if either the SymboList does not support the edit, or if the change was vetoed

### equals

    public boolean equals(Object o)

  Provides logical equality for two SymbolLists that share the same list of canonical symbols

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD